/*----------------------------------------------------------------------------*/
/* Teknisa Sistemas Integrados                                                */
/* 6704_ORESTPS_GERA_COMPOSICAO_RETIRADA.SQL                                  */
/* Autor: Diego Gonalves                                                     */
/* Data: 26/01/2010                                                           */
/* Descrio:                                                                 */
/*    Insere os produtos da composio na tabela ITEMRETIORE de               */
/*  acordo com os parmetros usados na tela Parmetros para Matria Prima     */
/*----------------------------------------------------------------------------*/
IF EXISTS (SELECT * FROM SYSOBJECTS O, SYSUSERS U
           WHERE O.NAME = 'GERA_COMPOSICAO_RETIRADA ' AND
                 TYPE = 'P' 		      AND
	              U.UID = O.UID           AND
	              U.NAME = USER)
DROP PROCEDURE GERA_COMPOSICAO_RETIRADA
GO

CREATE PROCEDURE GERA_COMPOSICAO_RETIRADA (@P_CDFILIAL          VARCHAR(4),
                                           @P_NRRETIRADAORE     VARCHAR(10),
                                           @P_NRITEMRETIORE     VARCHAR(5),
                                           @P_CDPRODUTO         VARCHAR(10),
                                           @P_QTITEMPED         DOUBLE PRECISION,
                                           @P_DTATUAL           DATETIME,
                                           @P_IDTIPENTSAID      VARCHAR(1),
                                           @P_CDOPERADOR        VARCHAR(12),
                                           @P_NRPEDIDO          VARCHAR(10),
                                           @P_NRITEMPED         VARCHAR(10),
                                           @P_IDTIPORETIORE     VARCHAR(1) = '',
                                           @P_CDPRODORIGITRET   VARCHAR(10) = '')
AS
BEGIN
   DECLARE @V_NRITEMRETIORE  VARCHAR(5);
   DECLARE @V_IDTIPORETIORE  VARCHAR(1);
   DECLARE @V_COTLOCAL       DOUBLE PRECISION;
   DECLARE @V_COTPADRAO      DOUBLE PRECISION;
   DECLARE @V_VERIFITEMRETI  DOUBLE PRECISION;
   DECLARE @V_CDPRODUTO      VARCHAR(10);
   DECLARE @V_CDSUBPRODLOC   VARCHAR(10);
   DECLARE @V_QTSUBPRODLOC   DOUBLE PRECISION;
   DECLARE @V_CDSUBPRODUTO   VARCHAR(10);
   DECLARE @V_QTSUBPRODROT   DOUBLE PRECISION;
   DECLARE @V_QTPRODCOMP     DOUBLE PRECISION;
END
GO

ALTER PROCEDURE GERA_COMPOSICAO_RETIRADA ( @P_CDFILIAL          VARCHAR(4),
                                           @P_NRRETIRADAORE     VARCHAR(10),
                                           @P_NRITEMRETIORE     VARCHAR(5),
                                           @P_CDPRODUTO         VARCHAR(10),
                                           @P_QTITEMPED         DOUBLE PRECISION,
                                           @P_DTATUAL           DATETIME,
                                           @P_IDTIPENTSAID      VARCHAR(1),
                                           @P_CDOPERADOR        VARCHAR(12),
                                           @P_NRPEDIDO          VARCHAR(10),
                                           @P_NRITEMPED         VARCHAR(10),
                                           @P_IDTIPORETIORE     VARCHAR(1) = '',
                                           @P_CDPRODORIGITRET   VARCHAR(10) = '')
AS
BEGIN
   DECLARE @V_NRITEMRETIORE  VARCHAR(5);
   DECLARE @V_IDTIPORETIORE  VARCHAR(1);
   DECLARE @V_COTLOCAL       DOUBLE PRECISION;
   DECLARE @V_COTPADRAO      DOUBLE PRECISION;
   DECLARE @V_VERIFITEMRETI  DOUBLE PRECISION;
   DECLARE @V_CDPRODUTO      VARCHAR(10);
   DECLARE @V_CDSUBPRODLOC   VARCHAR(10);
   DECLARE @V_QTSUBPRODLOC   DOUBLE PRECISION;
   DECLARE @V_CDSUBPRODUTO   VARCHAR(10);
   DECLARE @V_QTSUBPRODROT   DOUBLE PRECISION;
   DECLARE @V_QTPRODCOMP     DOUBLE PRECISION;


   SET @V_QTPRODCOMP = 0;

   SET @V_NRITEMRETIORE = '';

   SELECT @V_NRITEMRETIORE = RIGHT(REPLICATE ('0', 5) + CONVERT(VARCHAR, (ISNULL(MAX(NRITEMRETIORE), 0) + 1)), 5)
     FROM ITEMRETIORE
    WHERE CDFILIAL      = @P_CDFILIAL
      AND NRRETIRADAORE = @P_NRRETIRADAORE;

   SELECT @V_IDTIPORETIORE = IDTIPORETIORE
     FROM PRODUTO
    WHERE CDPRODUTO = @P_CDPRODUTO;

    SET @V_IDTIPORETIORE = ISNULL(@P_IDTIPORETIORE, @V_IDTIPORETIORE);

   IF @V_IDTIPORETIORE = 'C' BEGIN
      /*Verifica se existe composio Local para o produto informado.*/
      SELECT @V_COTLOCAL = COUNT(*)
        FROM ROTFABLOCAL R
       WHERE (R.CDFILIAL  = @P_CDFILIAL )
         AND (R.CDPRODUTO = @P_CDPRODUTO);

      IF @V_COTLOCAL > 0 BEGIN
         /* Composio Local */
         DECLARE C_COMPLOCAL CURSOR FOR
         SELECT R.CDPRODUTO, R.CDSUBPRODLOC, R.QTSUBPRODLOC
            FROM ROTFABLOCAL R
           WHERE (R.CDFILIAL  = @P_CDFILIAL )
             AND (R.CDPRODUTO = @P_CDPRODUTO)
           ORDER BY R.NRSEQPRODLOC;
         OPEN C_COMPLOCAL;
         FETCH NEXT FROM C_COMPLOCAL INTO @V_CDPRODUTO, @V_CDSUBPRODLOC, @V_QTSUBPRODLOC;

         WHILE (@@FETCH_STATUS = 0) BEGIN
            SET @V_QTPRODCOMP = (@V_QTSUBPRODLOC * @P_QTITEMPED);
            EXECUTE TEKNISA.GERA_COMPOSICAO_RETIRADA @P_CDFILIAL, @P_NRRETIRADAORE, @V_NRITEMRETIORE,
                                                     @V_CDSUBPRODLOC, @V_QTPRODCOMP,
                                                     @P_DTATUAL, @P_IDTIPENTSAID, @P_CDOPERADOR, @P_NRPEDIDO, @P_NRITEMPED, '', @P_CDPRODORIGITRET;

            FETCH NEXT FROM C_COMPLOCAL INTO @V_CDPRODUTO, @V_CDSUBPRODLOC, @V_QTSUBPRODLOC;
         END;
         CLOSE C_COMPLOCAL;
         DEALLOCATE C_COMPLOCAL;
      END
      ELSE BEGIN
         /*Verifica se existe composio Padro para o produto informado.*/
         SELECT @V_COTPADRAO = COUNT(*)
           FROM ROTFABRICA R
          WHERE (R.CDPRODUTO    = @P_CDPRODUTO);

         IF @V_COTPADRAO > 0 BEGIN
            /*Composio Padro*/
            DECLARE C_COMPPADRAO CURSOR FOR
            SELECT R.CDPRODUTO, R.CDSUBPRODUTO, R.QTSUBPRODROT
               FROM ROTFABRICA R
              WHERE (R.CDPRODUTO    = @P_CDPRODUTO)
              ORDER BY R.CDPRODUTO;
            OPEN C_COMPPADRAO;
            FETCH NEXT FROM C_COMPPADRAO INTO @V_CDPRODUTO, @V_CDSUBPRODUTO, @V_QTSUBPRODROT;

            WHILE (@@FETCH_STATUS = 0) BEGIN
               SET @V_QTPRODCOMP = (@V_QTSUBPRODROT * @P_QTITEMPED);
               EXECUTE TEKNISA.GERA_COMPOSICAO_RETIRADA @P_CDFILIAL, @P_NRRETIRADAORE, @V_NRITEMRETIORE,
                                                        @V_CDSUBPRODUTO, @V_QTPRODCOMP,
                                                        @P_DTATUAL, @P_IDTIPENTSAID, @P_CDOPERADOR, @P_NRPEDIDO, @P_NRITEMPED, '', @P_CDPRODORIGITRET;

               FETCH NEXT FROM C_COMPPADRAO INTO @V_CDPRODUTO, @V_CDSUBPRODUTO, @V_QTSUBPRODROT;
            END;
            CLOSE C_COMPPADRAO;
            DEALLOCATE C_COMPPADRAO;
         END
         ELSE BEGIN
            /*Verifica se o item ja est na tabela ITEMRETIORE*/
            SELECT @V_VERIFITEMRETI = ISNULL(COUNT(*), 0)
              FROM ITEMRETIORE
             WHERE CDFILIALPED   = @P_CDFILIAL
               AND NRPEDIDO      = @P_NRPEDIDO
               AND NRITEMPED     = @P_NRITEMPED
               AND CDPRODUTO     = @P_CDPRODUTO
               AND IDLANCRETIORE = @P_IDTIPENTSAID;

            IF @V_VERIFITEMRETI = 0 BEGIN
               INSERT INTO ITEMRETIORE
                  (CDFILIAL, NRRETIRADAORE, NRITEMRETIORE, CDPRODUTO, QTPREVITRETIORE,
                   QTMOVIITRETIORE, DTMOVIITRETIORE, IDLANCRETIORE, CDOPERADOR, CDFILIALPED, NRPEDIDO, NRITEMPED, CDPRODORIGITRET)
               VALUES
                  (@P_CDFILIAL , @P_NRRETIRADAORE, @V_NRITEMRETIORE, @P_CDPRODUTO, @P_QTITEMPED,
                   @P_QTITEMPED, @P_DTATUAL, @P_IDTIPENTSAID, @P_CDOPERADOR, @P_CDFILIAL, @P_NRPEDIDO, @P_NRITEMPED, @P_CDPRODORIGITRET);
            END;
         END;
      END;
   END
   ELSE BEGIN
      /*Verifica se o item ja est na tabela ITEMRETIORE*/
      SELECT @V_VERIFITEMRETI = ISNULL(COUNT(*), 0)
        FROM ITEMRETIORE
       WHERE CDFILIALPED   = @P_CDFILIAL
         AND NRPEDIDO      = @P_NRPEDIDO
         AND NRITEMPED     = @P_NRITEMPED
         AND CDPRODUTO     = @P_CDPRODUTO
         AND IDLANCRETIORE = @P_IDTIPENTSAID;

      IF @V_VERIFITEMRETI = 0 BEGIN
         INSERT INTO ITEMRETIORE
            (CDFILIAL, NRRETIRADAORE, NRITEMRETIORE, CDPRODUTO, QTPREVITRETIORE,
             QTMOVIITRETIORE, DTMOVIITRETIORE, IDLANCRETIORE, CDOPERADOR, CDFILIALPED, NRPEDIDO, NRITEMPED, CDPRODORIGITRET)
         VALUES
            (@P_CDFILIAL , @P_NRRETIRADAORE, @V_NRITEMRETIORE, @P_CDPRODUTO, @P_QTITEMPED,
             @P_QTITEMPED, @P_DTATUAL, @P_IDTIPENTSAID, @P_CDOPERADOR, @P_CDFILIAL, @P_NRPEDIDO, @P_NRITEMPED, @P_CDPRODORIGITRET);
      END;
   END;
END;
GO

-- VERSAO --
EXEC ATUVEROBJ 'GERA_COMPOSICAO_RETIRADA','5.09.014';
GO
